# -*- coding: utf-8 -*-
"""
Created on Thu May 17 23:32:34 2018
[tegaki_hantei_SVC_02.py]
@author: kenken
"""
#-----------------------------------
#from sklearn import datasets,cross_validation,svm,metrics#「cross_validation」は020から対応がなくなる！
#確認；今回入れた「scikit-learn」は「0.19.1」だ！けど、同じエラーが出た
from sklearn import datasets,model_selection,svm, metrics
import numpy as np
from PIL import Image
#from matplotlib import pylab as plt
#-----------------------------------
print("step1")
digits=datasets.load_digits()
#　テスト用「手書き数字」画像の取込みと加工
image=Image.open("tegaki_01.png").convert('L')
image=image.resize((8,8),Image.LANCZOS)
#image=image.resize((8,8),Image.ANTIALIAS)
img=np.asarray(image,dtype=float)
img=np.floor(16-16*(img/256))
img=img.flatten()
#　学習用データの準備
data_train=digits.data
label_train=digits.target
# テストデータを設定
data_test=img
label_test=[5]

print("step2")
#
print("digits.data[5]=",data_train[5])
print("data_test= ",data_test)

print("digits.data[5]=",digits.data[5].shape)
print("data_test= ",data_test.shape)
#　機械学習の実施
clf=svm.SVC(gamma=0.001)
clf.fit(data_train,label_train)
#

print("step3")
'''
#predict=clf.predict(data_test)
#出現エラー；
 Expected 2D array, got 1D array instead:
array=[0. 0. 2. ... 0. 0. 0.].
Reshape your data either using array.reshape(-1, 1)
 if your data has a single feature or array.reshape(1, -1)
 if it contains a single sample.
！！data_testは１個（シングル・データ）のために、この処理が必要なのか！！？？
'''
print("--------------予測結果---------------")
#　手書き数字の判定を実行
predict=clf.predict(data_test.reshape(1,-1))
print("テストラベル",label_test)
print("解析結果",predict)

print("-----------データの確認-----------------------")
print("data_test.reshape(1,-1)=",data_test.reshape(1,-1))
print("-----------最後に！-----------------------")
#　正解率を計算
ac_score=metrics.accuracy_score(label_test,predict)
print("正解率",ac_score*100,"%")
print("ようやく完了")

'''
♦参考（重要）；
data_train[5]
Out[28]: array([ 0.,  0., 12., ..., 10.,  0.,  0.])

data_test
Out[29]: array([0., 0., 2., ..., 0., 0., 0.])

data_test.reshape(1,-1)
Out[30]: array([[0., 0., 2., ..., 0., 0., 0.]])
２次元配列になってる！
もしかして、data_train[5]は、２次元配列データの内の、１行分データなので、
テストデータも、２次元配列データの１つ、と言う形式にしておく必要があるのでは？！
・・・・・・・・
この記法は， shape に (1, -1) や (-1, 1) を指定すると，それぞれ2次元の横ベクトルや縦ベクトルを簡便に作ることができます．
In [40]: np.arange(6).reshape((1, -1))
Out[40]: array([[0, 1, 2, 3, 4, 5]])
In [41]: np.arange(6).reshape((-1, 1))
Out[41]:
array([[0],
       [1],
       [2],
       [3],
       [4],
       [5]])

'''



